Index: DCWoRMS/branches/coolemall/src/schedframe/resources/computing/ComputingNode.java
===================================================================
--- DCWoRMS/branches/coolemall/src/schedframe/resources/computing/ComputingNode.java	(revision 756)
+++ DCWoRMS/branches/coolemall/src/schedframe/resources/computing/ComputingNode.java	(revision 1207)
@@ -3,5 +3,4 @@
 import java.util.List;
 import java.util.Properties;
-
 
 import schedframe.resources.ResourceStatus;
@@ -10,9 +9,5 @@
 import schedframe.resources.computing.extensions.ExtensionType;
 import schedframe.resources.computing.profiles.energy.EnergyExtension;
-import schedframe.resources.computing.profiles.energy.airthroughput.AirThroughputInterfaceFactory;
-import schedframe.resources.computing.profiles.energy.airthroughput.ui.AirThroughputInterface;
-import schedframe.resources.computing.profiles.energy.power.PowerInterfaceFactory;
 import schedframe.resources.computing.profiles.energy.power.ui.ComputingNodePowerInterface;
-import schedframe.resources.computing.profiles.energy.power.ui.PowerInterface;
 import schedframe.resources.computing.properties.ComputingNodePropertiesBuilder;
 import schedframe.resources.computing.properties.PropertiesDirector;
@@ -32,13 +27,5 @@
 		//accept(new EnergyExtension(pi, resDesc.getPowerProfile()));
 		//accept(new EnergyExtension(pi, resDesc.getPowerProfile(), ai, resDesc.getAirThroughputProfile()));	
-	}
-	
-	/*public ComputingNode (String resourceName, ResourceCharacteristics resourceCharacteristic, Category cat, PowerInterface powerInterface) {
-		super(resourceName, ResourceType.COMPUTING_NODE, resourceCharacteristic);
-		category = cat;
-		accept(powerInterface);
-	//	extensionList.add(new EnergyExtension(this, "example.energy.ComputingNodeEnergyEstimationPlugin"));
-	}*/
-	
+	}	
 	
 	public ComputingNodePowerInterface getPowerInterface(){
@@ -86,5 +73,5 @@
 	
 	public Memory getMemory() throws NoSuchFieldException {
-		return (Memory) resourceCharacteristic.getResourceUnit(StandardResourceUnitName.MEMORY);
+		return (Memory) ((ComputingResourceCharacteristics)resourceCharacteristic).getResourceUnit(StandardResourceUnitName.MEMORY);
 	}
 	
@@ -95,5 +82,5 @@
 	
 	private Cost getCost() throws NoSuchFieldException {
-		return (Cost) resourceCharacteristic.getResourceUnit(StandardResourceUnitName.COST);
+		return (Cost) ((ComputingResourceCharacteristics)resourceCharacteristic).getResourceUnit(StandardResourceUnitName.COST);
 	}
 
Index: DCWoRMS/branches/coolemall/src/schedframe/resources/CoolEmAllResourceFactory.java
===================================================================
--- DCWoRMS/branches/coolemall/src/schedframe/resources/CoolEmAllResourceFactory.java	(revision 1207)
+++ DCWoRMS/branches/coolemall/src/schedframe/resources/CoolEmAllResourceFactory.java	(revision 1207)
@@ -0,0 +1,56 @@
+package schedframe.resources;
+
+import schedframe.resources.computing.ComputingResource;
+import schedframe.resources.computing.Core;
+import schedframe.resources.computing.DataCenter;
+import schedframe.resources.computing.Processor;
+import schedframe.resources.computing.ResourceFactory;
+import schedframe.resources.computing.coolemall.ComputeBox1;
+import schedframe.resources.computing.coolemall.Node;
+import schedframe.resources.computing.coolemall.NodeGroup;
+import schedframe.resources.computing.description.ComputingResourceDescription;
+import schedframe.scheduling.Scheduler;
+import schedframe.scheduling.manager.resources.ManagedResources;
+import schedframe.scheduling.plugin.SchedulingPlugin;
+import schedframe.scheduling.plugin.estimation.ExecutionTimeEstimationPlugin;
+import schedframe.scheduling.policy.AbstractManagementSystem;
+import schedframe.scheduling.policy.local.LocalManagementSystem;
+import schedframe.scheduling.queue.TaskQueueList;
+import simulator.DCWormsConstants;
+
+public class CoolEmAllResourceFactory implements ResourceFactory{
+	
+	public ComputingResource createComputingResource(ComputingResourceDescription resDesc){
+		
+		if (resDesc.getType().getName().equals(StandardResourceType.DataCenter.getName()))
+			return new DataCenter(resDesc);
+		else if (resDesc.getType().getName().equals(StandardResourceType.Rack.getName()))
+			return new ComputeBox1(resDesc);
+		else if (resDesc.getType().getName().equals(CoolEmAllResourceType.NodeGroup.getName()))
+			return new NodeGroup(resDesc);
+		else if (resDesc.getType().getName().equals(StandardResourceType.Node.getName()))
+			return new Node(resDesc);
+		else if (resDesc.getType().getName().equals(StandardResourceType.Processor.getName()))
+			return new Processor(resDesc);
+		else if (resDesc.getType().getName().equals(StandardResourceType.Core.getName()))
+			return new Core(resDesc);
+		else return new ComputingResource(resDesc);
+	}
+
+	public Scheduler createScheduler(StandardResourceType type, String id, SchedulingPlugin schedulingPlugin, ExecutionTimeEstimationPlugin execTimeEstimationPlugin, TaskQueueList queues, ManagedResources managedResources) throws Exception{
+		AbstractManagementSystem ms;
+		switch(type){
+			case LS: {
+				ms = new LocalManagementSystem(id, DCWormsConstants.MANAGEMENT_SYSTEM,
+						schedulingPlugin, execTimeEstimationPlugin, queues);
+				return new Scheduler(ms, type, managedResources);
+			}
+
+		default:{
+				ms = new LocalManagementSystem(id, DCWormsConstants.MANAGEMENT_SYSTEM,
+						schedulingPlugin, execTimeEstimationPlugin, queues);
+				return new Scheduler(ms, type, managedResources);
+			}
+		}
+	}
+}
Index: DCWoRMS/branches/coolemall/src/schedframe/resources/StandardResourceType.java
===================================================================
--- DCWoRMS/branches/coolemall/src/schedframe/resources/StandardResourceType.java	(revision 1095)
+++ DCWoRMS/branches/coolemall/src/schedframe/resources/StandardResourceType.java	(revision 1207)
@@ -7,5 +7,5 @@
 	DataCenter,
 	Rack,
-	ComputingNode,
+	Node,
 	Processor,
 	Core,
@@ -13,5 +13,19 @@
 	ResourceProvider,
 	GS,
-	LS;
+	LS,
+	Fan,
+	Refrigeration,
+	Heatpipe,
+	ILC,
+	LCU,
+	CRAH,
+	HVAC,
+	Inlet,
+	Outlet,
+	Heatsink,
+	Sensor,
+	Network,
+	CoolingDevice,
+	PowerSupply;
 
 	public String getName() {
Index: DCWoRMS/branches/coolemall/src/schedframe/resources/utils/ResourceIdGenerator.java
===================================================================
--- DCWoRMS/branches/coolemall/src/schedframe/resources/utils/ResourceIdGenerator.java	(revision 816)
+++ DCWoRMS/branches/coolemall/src/schedframe/resources/utils/ResourceIdGenerator.java	(revision 1207)
@@ -2,6 +2,4 @@
 
 import java.util.HashMap;
-
-import schedframe.resources.ResourceType;
 
 public class ResourceIdGenerator {
@@ -11,5 +9,5 @@
 	public static int getId(String key){
 
-		int value = 0;
+		int value = 1;
 		if(resourceCounter.containsKey(key)){
 			value = resourceCounter.get(key);
Index: DCWoRMS/branches/coolemall/src/example/energy/ProcessorEnergyEstimationPlugin.java
===================================================================
--- DCWoRMS/branches/coolemall/src/example/energy/ProcessorEnergyEstimationPlugin.java	(revision 901)
+++ DCWoRMS/branches/coolemall/src/example/energy/ProcessorEnergyEstimationPlugin.java	(revision 1207)
@@ -2,8 +2,8 @@
 
 import schedframe.resources.ResourceStatus;
-import schedframe.resources.computing.ComputingResource;
 import schedframe.resources.computing.Processor;
 import schedframe.resources.computing.profiles.energy.EnergyEvent;
 import schedframe.resources.computing.profiles.energy.power.StandardPowerStateName;
+import schedframe.resources.devices.PhysicalResource;
 import schedframe.scheduling.manager.tasks.JobRegistry;
 
@@ -11,6 +11,7 @@
 
 	public double estimatePowerConsumption(EnergyEvent event, JobRegistry jobRegistry,
-			ComputingResource resource) {
+			PhysicalResource resource) {
 		double powerConsumption;
+
 		Processor cpu = (Processor)resource;
 		if(resource.getPowerInterface().getPowerState().equals(StandardPowerStateName.OFF))
Index: DCWoRMS/branches/coolemall/src/example/energy/coolemall/ProcessorEnergyEstimationPlugin.java
===================================================================
--- DCWoRMS/branches/coolemall/src/example/energy/coolemall/ProcessorEnergyEstimationPlugin.java	(revision 913)
+++ DCWoRMS/branches/coolemall/src/example/energy/coolemall/ProcessorEnergyEstimationPlugin.java	(revision 1207)
@@ -1,11 +1,14 @@
 package example.energy.coolemall;
 
-import schedframe.Parameter;
+import dcworms.schedframe.scheduling.ExecTask;
 import schedframe.resources.ResourceStatus;
-import schedframe.resources.computing.ComputingResource;
+import schedframe.resources.computing.Core;
 import schedframe.resources.computing.Processor;
 import schedframe.resources.computing.profiles.energy.EnergyEvent;
 import schedframe.resources.computing.profiles.energy.power.StandardPowerStateName;
+import schedframe.resources.devices.PhysicalResource;
 import schedframe.scheduling.manager.tasks.JobRegistry;
+import schedframe.scheduling.manager.tasks.JobRegistryImpl;
+import schedframe.scheduling.tasks.phases.PhaseBehaviour;
 import example.energy.BaseEnergyEstimationPlugin;
 
@@ -13,6 +16,7 @@
 
 	public double estimatePowerConsumption(EnergyEvent event, JobRegistry jobRegistry,
-			ComputingResource resource) {
-		double powerConsumption = 0;
+			PhysicalResource resource) {
+		
+		/*double powerConsumption = 0;
 		Processor cpu = (Processor)resource;
 		if(resource.getPowerInterface().getPowerState().equals(StandardPowerStateName.OFF))
@@ -38,4 +42,121 @@
 			}
 		}
+		return powerConsumption;*/
+		double powerConsumption = 0;
+		Processor proc = (Processor)resource;
+		if(resource.getPowerInterface().getPowerState().equals(StandardPowerStateName.OFF))
+			return 0;
+		else {
+			double processorLoad;
+			double sumCoresLoad = 0;
+			
+			int nrOfThreadsOnCpu = 1;
+			
+			if(proc.getResourceCharacteristic().getParameters().get("product") != null){
+				String productName = proc.getResourceCharacteristic().getParameters().get("product").get(0).getContent();
+				if(productName.equals("Fusion G - T40N"))
+					nrOfThreadsOnCpu = CoolEmAllTestbedMeasurements.Fusion_G_T40N_NR_OF_THREADS;
+				else if(productName.equals("Atom - D510"))
+					nrOfThreadsOnCpu = CoolEmAllTestbedMeasurements.Atom_D510_NR_OF_THREADS;
+				else if(productName.equals("Atom - N2600"))
+					nrOfThreadsOnCpu = CoolEmAllTestbedMeasurements.Atom_N2600_NR_OF_THREADS;
+				else if(productName.equals("Core i7 - 2715QE"))
+					nrOfThreadsOnCpu = CoolEmAllTestbedMeasurements.Core_i7_2715QE_NR_OF_THREADS;
+				else if(productName.equals("Core i7 - 3615QE"))
+					nrOfThreadsOnCpu = CoolEmAllTestbedMeasurements.Core_i7_3615QE_NR_OF_THREADS;
+			}
+
+			for(Core core: proc.getCores()){
+				
+				if(core.getStatus().equals(ResourceStatus.BUSY)){
+					JobRegistry jr = new JobRegistryImpl(core.getFullName());
+					for(ExecTask task: jr.getRunningTasks()){
+						double cpuUsage = 100;
+						double nrOfThreadsOfApplciation = 1;
+						for(PhaseBehaviour pb: task.getCurrentResourceConsumption().getBehaviourList()){
+							if(pb.getResouceName().equals("PM_CPU_Usage")){
+								cpuUsage = pb.getUtilization();
+							}
+							if(pb.getResouceName().equals("PM_Threads")){
+								nrOfThreadsOfApplciation = pb.getUtilization();
+								break;
+							}
+						}
+						sumCoresLoad = sumCoresLoad + cpuUsage * (nrOfThreadsOnCpu / nrOfThreadsOfApplciation);
+					}
+				}
+			}
+			processorLoad = 100 * sumCoresLoad/proc.getCores().size();
+			double lowestLoadLevel = 100;
+			double highestLoadLevel = 0;
+			if(proc.getPowerInterface().getPState().getLoadPowerUsage().containsKey(new Double(processorLoad))){
+				powerConsumption = proc.getPowerInterface().getPState().getLoadPowerUsage().get(new Double(processorLoad));
+				//System.out.println("power from profile: " + powerConsumption);
+			} else {
+				for(Double load: proc.getPowerInterface().getPState().getLoadPowerUsage().keySet()){
+					if(lowestLoadLevel > load){
+						lowestLoadLevel = load;
+					}
+					if(highestLoadLevel < load){
+						highestLoadLevel = load;
+					}
+				}
+				if(processorLoad == 0){
+					try{
+						powerConsumption = proc.getPowerInterface().getSupportedPowerStates().get(0).getPowerUsage();
+						//System.out.println("load = 0; power = idle power usage: " + powerConsumption);
+					} catch (Exception e){
+						powerConsumption = 0.7 * proc.getPowerInterface().getPState().getLoadPowerUsage().get(new Double(highestLoadLevel));
+						//System.out.println("error load = 0; power = 0.7 max power: " + powerConsumption);
+					}
+				} else {
+					
+					double lowerLoadLevel = lowestLoadLevel;
+					double higherLoadLevel = highestLoadLevel;
+					
+					try{
+					
+						for(Double load: proc.getPowerInterface().getPState().getLoadPowerUsage().keySet()){
+							if(processorLoad > load){
+								lowerLoadLevel = load;
+							}
+							else if(processorLoad < load){
+								higherLoadLevel = load;
+								break;
+							}
+						}
+						double powerBelow;
+						double powerAbove;
+						double a;
+						double b;
+						if(lowerLoadLevel != higherLoadLevel)
+						{
+							powerBelow = proc.getPowerInterface().getPState().getLoadPowerUsage().get(lowerLoadLevel);
+							powerAbove = proc.getPowerInterface().getPState().getLoadPowerUsage().get(higherLoadLevel);
+							a = (powerAbove - powerBelow)/(higherLoadLevel - lowerLoadLevel);
+							b = powerAbove - a * higherLoadLevel;
+						} else {
+							powerBelow = proc.getPowerInterface().getPState().getLoadPowerUsage().get(lowestLoadLevel);
+							powerAbove = proc.getPowerInterface().getPState().getLoadPowerUsage().get(highestLoadLevel);
+							a = (powerAbove - powerBelow)/(highestLoadLevel - lowestLoadLevel);
+							b = powerAbove - a * highestLoadLevel;
+						}
+						powerConsumption = a * processorLoad + b;
+						/*System.out.println("a" +lowestLoadLevel + ";" +highestLoadLevel);
+						System.out.println("b" +lowerLoadLevel + ";" +higherLoadLevel);
+						System.out.println("c" +powerBelow + ";" +powerAbove);
+						System.out.println(resource.getFullName() + "load: " + processorLoad + "linear power estimation " + powerConsumption);*/
+	
+					} catch (Exception e){
+						powerConsumption = 0.7 * proc.getPowerInterface().getPState().getLoadPowerUsage().get(new Double(highestLoadLevel));	
+						//System.out.println("error; power = 0.7 max power: " + powerConsumption);
+					}
+				}
+			}
+		}
+			
+
+		powerConsumption = powerConsumption - CoolEmAllTestbedMeasurements.SINGLE_FAN_ON_POWER_CONSUMPTION;
+		//System.out.println("estiamted power consumption: " + powerConsumption);
 		return powerConsumption;
 	}
Index: DCWoRMS/branches/coolemall/src/example/energy/coolemall/NodeGroupEnergyEstimationPlugin.java
===================================================================
--- DCWoRMS/branches/coolemall/src/example/energy/coolemall/NodeGroupEnergyEstimationPlugin.java	(revision 913)
+++ DCWoRMS/branches/coolemall/src/example/energy/coolemall/NodeGroupEnergyEstimationPlugin.java	(revision 1207)
@@ -1,9 +1,8 @@
 package example.energy.coolemall;
 
-import schedframe.Parameter;
-import schedframe.resources.computing.ComputingResource;
+import schedframe.resources.computing.coolemall.Node;
+import schedframe.resources.computing.coolemall.NodeGroup;
 import schedframe.resources.computing.profiles.energy.EnergyEvent;
-import schedframe.resources.computing.recs.Node;
-import schedframe.resources.computing.recs.NodeGroup;
+import schedframe.resources.devices.PhysicalResource;
 import schedframe.scheduling.manager.tasks.JobRegistry;
 import example.energy.BaseEnergyEstimationPlugin;
@@ -12,20 +11,13 @@
 
 	public double estimatePowerConsumption(EnergyEvent event, JobRegistry jobRegistry,
-			ComputingResource resource) {
+			PhysicalResource resource) {
+		
 		double powerConsumption = 0;
 		NodeGroup nodeGroup = (NodeGroup)resource;
-		for(Node cn: nodeGroup.getNodes()){
+		for(Node node: nodeGroup.getNodes()){
 			try{
-				powerConsumption = powerConsumption + cn.getPowerInterface().getRecentPowerUsage().getValue();
+				powerConsumption = powerConsumption + node.getPowerInterface().getRecentPowerUsage().getValue();
 			} catch (Exception e){
-				
 			}
-		}
-		try {
-			powerConsumption = powerConsumption + nodeGroup.getPowerInterface().getPowerConsumption(nodeGroup.getPowerInterface().getPowerState());
-		} catch (NoSuchFieldException e) {
-			Parameter param = nodeGroup.getResourceCharacteristic().getParameters().get("maxPower");
-			if(param != null)
-				powerConsumption = powerConsumption + Double.valueOf(param.get(0).getContent());
 		}
 
Index: DCWoRMS/branches/coolemall/src/example/energy/coolemall/CB1EnergyEstimationPlugin.java
===================================================================
--- DCWoRMS/branches/coolemall/src/example/energy/coolemall/CB1EnergyEstimationPlugin.java	(revision 913)
+++ DCWoRMS/branches/coolemall/src/example/energy/coolemall/CB1EnergyEstimationPlugin.java	(revision 1207)
@@ -1,9 +1,8 @@
 package example.energy.coolemall;
 
-import schedframe.Parameter;
-import schedframe.resources.computing.ComputingResource;
+import schedframe.resources.computing.coolemall.ComputeBox1;
+import schedframe.resources.computing.coolemall.NodeGroup;
 import schedframe.resources.computing.profiles.energy.EnergyEvent;
-import schedframe.resources.computing.recs.ComputeBox1;
-import schedframe.resources.computing.recs.NodeGroup;
+import schedframe.resources.devices.PhysicalResource;
 import schedframe.scheduling.manager.tasks.JobRegistry;
 import example.energy.BaseEnergyEstimationPlugin;
@@ -12,5 +11,5 @@
 
 	public double estimatePowerConsumption(EnergyEvent event, JobRegistry jobRegistry,
-			ComputingResource resource) {
+			PhysicalResource resource) {
 		double powerConsumption = 0;
 		ComputeBox1 computeBox1 = (ComputeBox1)resource;
@@ -22,14 +21,5 @@
 			}
 		}
-
-		try {
-			powerConsumption = powerConsumption + computeBox1.getPowerInterface().getPowerConsumption(computeBox1.getPowerInterface().getPowerState());
-		} catch (NoSuchFieldException e) {
-			Parameter param = computeBox1.getResourceCharacteristic().getParameters().get("maxPower");
-			if(param != null)
-				powerConsumption = powerConsumption + Double.valueOf(param.get(0).getContent());
-		}
-
-		
+		powerConsumption = (powerConsumption + CoolEmAllTestbedMeasurements.OTHER_DEVICES_POWER_CONSUMPTION)/CoolEmAllTestbedMeasurements.POWER_SUPPLY_EFFICIENCY;
 		return powerConsumption;
 	}
Index: DCWoRMS/branches/coolemall/src/example/energy/coolemall/CoolEmAllTestbedMeasurements.java
===================================================================
--- DCWoRMS/branches/coolemall/src/example/energy/coolemall/CoolEmAllTestbedMeasurements.java	(revision 1207)
+++ DCWoRMS/branches/coolemall/src/example/energy/coolemall/CoolEmAllTestbedMeasurements.java	(revision 1207)
@@ -0,0 +1,39 @@
+package example.energy.coolemall;
+
+public class CoolEmAllTestbedMeasurements {
+
+	//HARDWARE
+	public static final double SINGLE_FAN_ON_AIR_FLOW = 0.0112;
+	public static final double SINGLE_FAN_OFF_AIR_FLOW = 0;
+	
+	public static final double SINGLE_FAN_ON_POWER_CONSUMPTION = 6;
+	public static final double SINGLE_FAN_OFF_POWER_CONSUMPTION = 0;
+	
+	public static final double OTHER_DEVICES_POWER_CONSUMPTION = 775;
+	
+	public static final double POWER_SUPPLY_EFFICIENCY = 0.87;
+	
+
+	public static final int Atom_D510_NR_OF_THREADS = 2;
+	
+	public static final int Atom_N2600_NR_OF_THREADS = 2;
+	
+	public static final int Core_i7_2715QE_NR_OF_THREADS = 4;
+	
+	public static final int Core_i7_3615QE_NR_OF_THREADS = 4;
+	
+	public static final int Fusion_G_T40N_NR_OF_THREADS = 2;
+	
+	//APPLICATIONS
+	public static final double Atom_D510 = 336.3;
+	
+	public static final double Atom_N2600 = 336.3;
+	
+	public static final double Core_i7_2715QE = 3076.4;
+	
+	public static final double Core_i7_3615QE = 3786.0;
+	
+	public static final double Fusion_G_T40N = 649.3;
+	
+
+}
Index: DCWoRMS/branches/coolemall/src/example/energy/coolemall/FlowPumpInletEnergyEstimationPlugin.java
===================================================================
--- DCWoRMS/branches/coolemall/src/example/energy/coolemall/FlowPumpInletEnergyEstimationPlugin.java	(revision 1207)
+++ DCWoRMS/branches/coolemall/src/example/energy/coolemall/FlowPumpInletEnergyEstimationPlugin.java	(revision 1207)
@@ -0,0 +1,54 @@
+package example.energy.coolemall;
+
+import schedframe.resources.computing.profiles.energy.EnergyEvent;
+import schedframe.resources.devices.PhysicalResource;
+import schedframe.scheduling.manager.tasks.JobRegistry;
+import simulator.ConfigurationOptions;
+import example.energy.BaseEnergyEstimationPlugin;
+
+public class FlowPumpInletEnergyEstimationPlugin extends BaseEnergyEstimationPlugin {
+
+	public double estimatePowerConsumption(EnergyEvent event, JobRegistry jobRegistry,
+			PhysicalResource resource) {
+		
+		double powerConsumption = 0;
+
+		double nf = 0.6;
+
+		double delta_p;//from database, CFD
+		try{
+			delta_p = ConfigurationOptions.pressureDrop;
+		} catch (Exception e){
+			delta_p = 0;
+		}
+		
+		double Vair_total;
+		
+		try{
+			Vair_total = ConfigurationOptions.airFlowVolume;
+		} catch (Exception e){
+			Vair_total = 0;
+		}
+
+		
+		//if data not present in DB than don't take Pfans_dc into account
+		if(delta_p != -1 && Vair_total != -1)
+			powerConsumption = delta_p * Vair_total / nf;
+		
+		return powerConsumption;
+	}
+	
+	public double estimateAirThroughput(EnergyEvent event, JobRegistry jobRegistry, PhysicalResource resource) {
+		double airThroughput = 0;
+		double Vair_total;
+		
+		try{
+			Vair_total = ConfigurationOptions.airFlowVolume;
+		} catch (Exception e){
+			Vair_total = 0;
+		}
+		airThroughput = Vair_total;
+		return airThroughput;
+	}
+
+}
Index: DCWoRMS/branches/coolemall/src/example/energy/coolemall/NodeEnergyEstimationPlugin.java
===================================================================
--- DCWoRMS/branches/coolemall/src/example/energy/coolemall/NodeEnergyEstimationPlugin.java	(revision 1146)
+++ DCWoRMS/branches/coolemall/src/example/energy/coolemall/NodeEnergyEstimationPlugin.java	(revision 1207)
@@ -1,20 +1,21 @@
 package example.energy.coolemall;
 
-import schedframe.Parameter;
-import schedframe.events.scheduling.EventReason;
-import schedframe.resources.computing.ComputingResource;
 import schedframe.resources.computing.Processor;
+import schedframe.resources.computing.coolemall.Node;
 import schedframe.resources.computing.profiles.energy.EnergyEvent;
-import schedframe.resources.computing.recs.Node;
+import schedframe.resources.computing.profiles.energy.power.StandardPowerStateName;
+import schedframe.resources.devices.Device;
+import schedframe.resources.devices.PhysicalResource;
 import schedframe.scheduling.manager.tasks.JobRegistry;
+import testbed_hpc.Node_Fan_Mapping;
 import example.energy.BaseEnergyEstimationPlugin;
 
 public class NodeEnergyEstimationPlugin extends BaseEnergyEstimationPlugin {
 
-	private static int OUT_START_ID = 0;
-	private static int OUT_END_ID = 8;
+	//private static int OUT_START_ID = 0;
+	//private static int OUT_END_ID = 8;
 	
 	public double estimatePowerConsumption(EnergyEvent event, JobRegistry jobRegistry,
-			ComputingResource resource) {
+			PhysicalResource resource) {
 		double powerConsumption = 0;
 		Node node = (Node) resource;
@@ -26,16 +27,22 @@
 			}
 		}
-		try {
-			powerConsumption = powerConsumption + node.getPowerInterface().getPowerConsumption(node.getPowerInterface().getPowerState());
-		} catch (NoSuchFieldException e) {
-			Parameter param = node.getResourceCharacteristic().getParameters().get("maxPower");
-			if(param != null)
-				powerConsumption = powerConsumption + Double.valueOf(param.get(0).getContent());
-		}
+		if(node.getPowerInterface().getPowerState().equals(StandardPowerStateName.ON)){
+			//powerConsumption = powerConsumption + CoolEmAllTestbedMeasurements.SINGLE_FAN_ON_POWER_CONSUMPTION;
+			for(Device device: node.getParent().getResourceCharacteristic().getDevices()){
+				if(device.getFullName().equals(Node_Fan_Mapping.getNode_fan().get(node.getFullName()))){
+					if(device.getPowerInterface().getRecentPowerUsage().getValue() == -1){
+						powerConsumption = powerConsumption + CoolEmAllTestbedMeasurements.SINGLE_FAN_ON_POWER_CONSUMPTION;
+					}else
+						powerConsumption = powerConsumption + device.getPowerInterface().getRecentPowerUsage().getValue();
+					break;
+				}
+			}
+		} 
+
 
 		return powerConsumption;
 	}
 
-	public double estimateAirThroughput(EnergyEvent event, JobRegistry jobRegistry, ComputingResource resource) {
+	/*public double estimateAirThroughput(EnergyEvent event, JobRegistry jobRegistry, PhysicalResource resource) {
 
 		double airThroughput = 0;
@@ -44,6 +51,9 @@
 				return airThroughput;
 				//airThroughput = resource.getAirThroughputInterface().getAirFlow(StandardAirThroughputStateName.FAN_OFF);
-			else
+			else {
 				airThroughput = resource.getAirThroughputInterface().getAirFlow(resource.getAirThroughputInterface().getAirThroughputState());
+				//airThroughput = computingResource.getResourceCharacteristic().getDevices().get(0).getAirThroughputInterface().getAirFlow(resource.getAirThroughputInterface().getAirThroughputState());
+				//airThroughput = 0.28;
+			}
 		} catch (NoSuchFieldException e) {
 			// TODO Auto-generated catch block
@@ -51,24 +61,25 @@
 		}
 		
-		Integer resId = Integer.parseInt(resource.getName().split("_")[1]);
+		//Integer resId = Integer.parseInt(resource.getName().split("_")[1]);
+		//ComputingResource computingResource = (ComputingResource) resource;
 		//we estimate the air flow related to the outlets (nodes placed in the outlet row of RECS)
-		if(resId >= OUT_START_ID  && resId <= OUT_END_ID){
-			for(ComputingResource compResource: resource.getParent().getChildren()){
-				Integer id = Integer.parseInt(compResource.getName().split("_")[1]);
-				//we take into account the inlet air flow (nodes placed "behind" the given node)
-				if(id - resId == 9 || id - resId == -9){
-					try {
-						airThroughput = airThroughput + compResource.getAirThroughputInterface().getAirFlow(compResource.getAirThroughputInterface().getAirThroughputState())/2;
-					} catch (NoSuchFieldException e) {
-		
-					}
-				}
-			}
-		}
+		//if(resId >= OUT_START_ID  && resId <= OUT_END_ID){
+		//	for(ComputingResource compResource: computingResource.getParent().getChildren()){
+		//		Integer id = Integer.parseInt(compResource.getName().split("_")[1]);
+		//		//we take into account the inlet air flow (nodes placed "behind" the given node)
+		//		if(id - resId == 9 || id - resId == -9){
+		//			try {
+		//				airThroughput = airThroughput + compResource.getAirThroughputInterface().getAirFlow(compResource.getAirThroughputInterface().getAirThroughputState())/2;
+		//			} catch (NoSuchFieldException e) {
+		//
+		//			}
+		//		}
+		//	}
+		//}
 
 		return airThroughput;
-	}
+	}*/
 
-	public double estimateTemperature(EnergyEvent event, JobRegistry jobRegistry, ComputingResource resource) {
+	/*public double estimateTemperature(EnergyEvent event, JobRegistry jobRegistry, PhysicalResource resource) {
 		double tout = 0;
 		double tin = 21.3;
@@ -83,6 +94,8 @@
 		Integer resId = Integer.parseInt(resource.getName().split("_")[1]);
 		
+		ComputingResource computingResource = (ComputingResource) resource;
+		
 		//we estimate outlet temperature (related to the temperature of the nodes placed in outlet row)
-		for(ComputingResource compResource: resource.getParent().getChildren()){
+		for(ComputingResource compResource: computingResource.getParent().getChildren()){
 			Integer id = Integer.parseInt(compResource.getName().split("_")[1]);
 			//we take into account the power of nodes placed "behind" the given nodes
@@ -98,5 +111,5 @@
 		tout = tin + delta1 * (power1/(Q * C * ro)) +  delta2 * (power2/(Q * C * ro));;
 		return tout;
-	}
+	}*/
 	
 }
